package schet

import "errors"

const (
	Сумма300тр = 300000
)

type Сумматор300тр struct {
	набегающим_итогом float64
	сверхСуммы        []float64
}

func NewСумматор300тр() *Сумматор300тр {
	return &Сумматор300тр{}
}

func (s *Сумматор300тр) Квартал(номер int) (float64, error) {
	index := номер - 1
	if index >= len(s.сверхСуммы) || index < 0 {
		return 0, errors.New("неизвестный квартал")
	}
	return s.сверхСуммы[index], nil
}

func (s *Сумматор300тр) ДобавитьКвартал(сумма float64) {
	сверх := s.сверх300трСуммаЗаКвартал(сумма)
	s.сверхСуммы = append(s.сверхСуммы, сверх)
}

func (s *Сумматор300тр) сверх300трСуммаЗаКвартал(сумма_за_квартал float64) float64 {
	сумма_предыдущих_кварталов := s.набегающим_итогом
	s.набегающим_итогом += сумма_за_квартал

	if s.набегающим_итогом <= Сумма300тр {
		return 0
	}

	if сумма_предыдущих_кварталов > Сумма300тр {
		return сумма_за_квартал
	}

	return s.набегающим_итогом - Сумма300тр
}

func ПроцентСверх300тр(сумма float64) float64 {
	свыше_300тр := сумма - Сумма300тр
	if свыше_300тр < 0 {
		свыше_300тр = 0
	}
	часть := процентСуммы(свыше_300тр)
	return часть
}
